//
// Generated by JTB 1.3.2
//

package org.objectweb.fractal.mind.adl.jtb.visitor;
import org.objectweb.fractal.mind.adl.jtb.syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
public class GJDepthFirst<R,A> implements GJVisitor<R,A> {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   public R visit(NodeList n, A argu) {
      R _ret=null;
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public R visit(NodeListOptional n, A argu) {
      if ( n.present() ) {
         R _ret=null;
         int _count=0;
         for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
            e.nextElement().accept(this,argu);
            _count++;
         }
         return _ret;
      }
      else
         return null;
   }

   public R visit(NodeOptional n, A argu) {
      if ( n.present() )
         return n.node.accept(this,argu);
      else
         return null;
   }

   public R visit(NodeSequence n, A argu) {
      R _ret=null;
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public R visit(NodeToken n, A argu) { return null; }

   //
   // User-generated visitor methods below
   //

   /**
    * <PRE>
    * f0 -> ( ImportDefinition() )*
    * f1 -> ArchitectureDefinition()
    * f2 -> &lt;EOF&gt;
    * </PRE>
    */
   public R visit(ADLFile n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> ( Annotation() )*
    * f1 -> &lt;IMPORT&gt;
    * f2 -> &lt;IDENTIFIER&gt;
    * f3 -> &lt;DOT&gt;
    * f4 -> ( &lt;IDENTIFIER&gt; &lt;DOT&gt; )*
    * f5 -> ( &lt;START&gt; | &lt;IDENTIFIER&gt; )
    * f6 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(ImportDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> ( TypeDefinition() | PrimitiveDefinition() | CompositeDefinition() )
    * </PRE>
    */
   public R visit(ArchitectureDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;TYPE&gt;
    * f2 -> FullyQualifiedName()
    * f3 -> [ ExtendedTypeDefinitions() ]
    * f4 -> TypeDefinitionBody()
    * </PRE>
    */
   public R visit(TypeDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;EXTENDS&gt;
    * f1 -> TypeDefinitionReference()
    * f2 -> ( &lt;COMMA&gt; TypeDefinitionReference() )*
    * </PRE>
    */
   public R visit(ExtendedTypeDefinitions n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> FullyQualifiedName()
    * </PRE>
    */
   public R visit(TypeDefinitionReference n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt; ( TypeDefinitionElement() )* &lt;RBRACE&gt;
    *       | ( TypeDefinitionElement() )*
    * </PRE>
    */
   public R visit(TypeDefinitionBody n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> InterfaceDefinition()
    * </PRE>
    */
   public R visit(TypeDefinitionElement n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> [ &lt;ABSTRACT&gt; ]
    * f2 -> &lt;PRIMITIVE&gt;
    * f3 -> FullyQualifiedName()
    * f4 -> [ FormalParameterDeclarationList() ]
    * f5 -> [ ExtendedPrimitiveDefinitions() ]
    * f6 -> PrimitiveDefinitionBody()
    * </PRE>
    */
   public R visit(PrimitiveDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt;
    * f1 -> [ FormalParameterDeclaration() ( &lt;COMMA&gt; FormalParameterDeclaration() )* ]
    * f2 -> &lt;RPAREN&gt;
    * </PRE>
    */
   public R visit(FormalParameterDeclarationList n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public R visit(FormalParameterDeclaration n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;EXTENDS&gt;
    * f1 -> PrimitiveDefinitionReference()
    * f2 -> ( &lt;COMMA&gt; PrimitiveDefinitionReference() )*
    * </PRE>
    */
   public R visit(ExtendedPrimitiveDefinitions n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> FullyQualifiedName()
    * f1 -> [ ArgumentList() ]
    * </PRE>
    */
   public R visit(PrimitiveDefinitionReference n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt;
    * f1 -> [ Argument() ( &lt;COMMA&gt; Argument() )* | ArgumentAssignement() ( &lt;COMMA&gt; ArgumentAssignement() )* ]
    * f2 -> &lt;RPAREN&gt;
    * </PRE>
    */
   public R visit(ArgumentList n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> &lt;ASSIGN&gt;
    * f2 -> Argument()
    * </PRE>
    */
   public R visit(ArgumentAssignement n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> StringValue()
    *       | IntegerValue()
    *       | ReferenceValue()
    * </PRE>
    */
   public R visit(Argument n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt; ( PrimitiveDefinitionElement() )* &lt;RBRACE&gt;
    *       | ( PrimitiveDefinitionElement() )*
    * </PRE>
    */
   public R visit(PrimitiveDefinitionBody n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> InterfaceDefinition()
    *       | AttributeDefinition()
    *       | DataDefinition()
    *       | ImplementationDefinition()
    * </PRE>
    */
   public R visit(PrimitiveDefinitionElement n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;COMPOSITE&gt;
    * f2 -> FullyQualifiedName()
    * f3 -> [ FormalTypeParameterDeclarationList() ]
    * f4 -> [ FormalParameterDeclarationList() ]
    * f5 -> [ ExtendedCompositeDefinitions() ]
    * f6 -> CompositeDefinitionBody()
    * </PRE>
    */
   public R visit(CompositeDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LT&gt;
    * f1 -> FormalTypeParameterDeclaration()
    * f2 -> ( &lt;COMMA&gt; FormalTypeParameterDeclaration() )*
    * f3 -> &lt;GT&gt;
    * </PRE>
    */
   public R visit(FormalTypeParameterDeclarationList n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> &lt;CONFORMSTO&gt;
    * f2 -> TypeDefinitionReference()
    * </PRE>
    */
   public R visit(FormalTypeParameterDeclaration n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> FullyQualifiedName()
    * f1 -> [ TypeArgumentList() ]
    * f2 -> [ ArgumentList() ]
    * </PRE>
    */
   public R visit(CompositeDefinitionReference n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LT&gt;
    * f1 -> [ TypeArgument() ( &lt;COMMA&gt; TypeArgument() )* | TypeArgumentAssignement() ( &lt;COMMA&gt; TypeArgumentAssignement() )* ]
    * f2 -> &lt;GT&gt;
    * </PRE>
    */
   public R visit(TypeArgumentList n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> &lt;ASSIGN&gt;
    * f2 -> TypeArgument()
    * </PRE>
    */
   public R visit(TypeArgumentAssignement n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> CompositeDefinitionReference()
    *       | &lt;ANY&gt;
    * </PRE>
    */
   public R visit(TypeArgument n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;EXTENDS&gt;
    * f1 -> CompositeDefinitionReference()
    * f2 -> ( &lt;COMMA&gt; CompositeDefinitionReference() )*
    * </PRE>
    */
   public R visit(ExtendedCompositeDefinitions n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt; ( CompositeDefinitionElement() )* &lt;RBRACE&gt;
    *       | ( CompositeDefinitionElement() )*
    * </PRE>
    */
   public R visit(CompositeDefinitionBody n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> InterfaceDefinition()
    *       | BindingDefinition()
    *       | SubComponentDefinition()
    * </PRE>
    */
   public R visit(CompositeDefinitionElement n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> ( &lt;PROVIDES&gt; | &lt;REQUIRES&gt; )
    * f2 -> [ &lt;OPTIONAL&gt; ]
    * f3 -> FullyQualifiedName()
    * f4 -> &lt;AS&gt;
    * f5 -> &lt;IDENTIFIER&gt;
    * f6 -> [ &lt;LBRACKET&gt; [ &lt;INTEGER_LITERAL&gt; ] &lt;RBRACKET&gt; ]
    * f7 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(InterfaceDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;ATTRIBUTE&gt;
    * f2 -> [ AttributeType() ]
    * f3 -> &lt;IDENTIFIER&gt;
    * f4 -> [ &lt;ASSIGN&gt; AttributeValue() ]
    * f5 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(AttributeDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;INT&gt;
    *       | &lt;STRING&gt;
    *       | &lt;INT8_T&gt;
    *       | &lt;UINT8_T&gt;
    *       | &lt;INT16_T&gt;
    *       | &lt;UINT16_T&gt;
    *       | &lt;INT32_T&gt;
    *       | &lt;UINT32_T&gt;
    *       | &lt;INT64_T&gt;
    *       | &lt;UINT64_T&gt;
    *       | &lt;INTPTR_T&gt;
    *       | &lt;UINTPTR_T&gt;
    * </PRE>
    */
   public R visit(AttributeType n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> StringValue()
    *       | IntegerValue()
    *       | ReferenceValue()
    * </PRE>
    */
   public R visit(AttributeValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> ( DataFileDefinition() | NoDataDefinition() )
    * f2 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(DataDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;DATA&gt;
    * f1 -> ( Path() | &lt;INLINED_CODE&gt; )
    * </PRE>
    */
   public R visit(DataFileDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;NODATA&gt;
    * </PRE>
    */
   public R visit(NoDataDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;SOURCE&gt;
    * f2 -> ( Path() | &lt;INLINED_CODE&gt; )
    * f3 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(ImplementationDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;BINDS&gt;
    * f2 -> BindingComponentName()
    * f3 -> &lt;DOT&gt;
    * f4 -> &lt;IDENTIFIER&gt;
    * f5 -> [ &lt;LBRACKET&gt; &lt;INTEGER_LITERAL&gt; &lt;RBRACKET&gt; ]
    * f6 -> &lt;TO&gt;
    * f7 -> BindingComponentName()
    * f8 -> &lt;DOT&gt;
    * f9 -> &lt;IDENTIFIER&gt;
    * f10 -> [ &lt;LBRACKET&gt; &lt;INTEGER_LITERAL&gt; &lt;RBRACKET&gt; ]
    * f11 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(BindingDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      n.f8.accept(this, argu);
      n.f9.accept(this, argu);
      n.f10.accept(this, argu);
      n.f11.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    *       | &lt;THIS&gt;
    * </PRE>
    */
   public R visit(BindingComponentName n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;CONTAINS&gt;
    * f2 -> SubComponentReference()
    * f3 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(SubComponentDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> CompositeSubComponentReference()
    *       | CompositeInlinedDefinition()
    *       | PrimitiveSubComponentReference()
    *       | PrimitiveInlinedDefinition()
    *       | SimpleSubComponentReference()
    * </PRE>
    */
   public R visit(SubComponentReference n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;COMPOSITE&gt;
    * f1 -> CompositeDefinitionReference()
    * f2 -> &lt;AS&gt;
    * f3 -> &lt;IDENTIFIER&gt;
    * f4 -> [ CompositeAnonymousExtension() ]
    * </PRE>
    */
   public R visit(CompositeSubComponentReference n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;COMPOSITE&gt;
    * f1 -> &lt;AS&gt;
    * f2 -> &lt;IDENTIFIER&gt;
    * f3 -> CompositeAnonymousExtension()
    * </PRE>
    */
   public R visit(CompositeInlinedDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;PRIMITIVE&gt;
    * f1 -> PrimitiveDefinitionReference()
    * f2 -> &lt;AS&gt;
    * f3 -> &lt;IDENTIFIER&gt;
    * f4 -> [ PrimitiveAnonymousExtension() ]
    * </PRE>
    */
   public R visit(PrimitiveSubComponentReference n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;PRIMITIVE&gt;
    * f1 -> &lt;AS&gt;
    * f2 -> &lt;IDENTIFIER&gt;
    * f3 -> PrimitiveAnonymousExtension()
    * </PRE>
    */
   public R visit(PrimitiveInlinedDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> [ CompositeDefinitionReference() ]
    * f1 -> &lt;AS&gt;
    * f2 -> &lt;IDENTIFIER&gt;
    * f3 -> [ ( PrimitiveAnonymousDefinition() | CompositeAnonymousDefinition() ) ]
    * </PRE>
    */
   public R visit(SimpleSubComponentReference n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;PRIMITIVE&gt;
    * f2 -> &lt;LBRACE&gt;
    * f3 -> ( PrimitiveDefinitionElement() )*
    * f4 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(PrimitiveAnonymousDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;COMPOSITE&gt;
    * f2 -> &lt;LBRACE&gt;
    * f3 -> ( CompositeDefinitionElement() )*
    * f4 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(CompositeAnonymousDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;LBRACE&gt;
    * f2 -> ( PrimitiveDefinitionElement() )*
    * f3 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(PrimitiveAnonymousExtension n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;LBRACE&gt;
    * f2 -> ( CompositeDefinitionElement() )*
    * f3 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(CompositeAnonymousExtension n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> ( Annotation() )*
    * </PRE>
    */
   public R visit(Annotations n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;AT&gt;
    * f1 -> FullyQualifiedName()
    * f2 -> [ AnnotationParameters() ]
    * </PRE>
    */
   public R visit(Annotation n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt;
    * f1 -> [ AnnotationValuePairs() | AnnotationValue() ]
    * f2 -> &lt;RPAREN&gt;
    * </PRE>
    */
   public R visit(AnnotationParameters n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> AnnotationValuePair()
    * f1 -> ( &lt;COMMA&gt; AnnotationValuePair() )*
    * </PRE>
    */
   public R visit(AnnotationValuePairs n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> &lt;ASSIGN&gt;
    * f2 -> AnnotationValue()
    * </PRE>
    */
   public R visit(AnnotationValuePair n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> StringValue()
    *       | IntegerValue()
    *       | BooleanValue()
    *       | AnnotationAnnotationValue()
    *       | ArrayAnnotationValue()
    * </PRE>
    */
   public R visit(AnnotationValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotation()
    * </PRE>
    */
   public R visit(AnnotationAnnotationValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt;
    * f1 -> [ AnnotationValue() ( &lt;COMMA&gt; AnnotationValue() )* ]
    * f2 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(ArrayAnnotationValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;STRING_LITERAL&gt;
    * </PRE>
    */
   public R visit(StringValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> [ &lt;MINUS&gt; | &lt;PLUS&gt; ]
    * f1 -> &lt;INTEGER_LITERAL&gt;
    * </PRE>
    */
   public R visit(IntegerValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;BOOLEAN_LITERAL&gt;
    * </PRE>
    */
   public R visit(BooleanValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public R visit(ReferenceValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> ( &lt;DOT&gt; &lt;IDENTIFIER&gt; )*
    * </PRE>
    */
   public R visit(FullyQualifiedName n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> [ &lt;DOT&gt; &lt;SLASH&gt; ]
    * f1 -> ( &lt;DOTDOT&gt; &lt;SLASH&gt; )*
    * f2 -> &lt;IDENTIFIER&gt;
    * f3 -> ( &lt;SLASH&gt; &lt;IDENTIFIER&gt; )*
    * f4 -> &lt;DOT&gt;
    * f5 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public R visit(Path n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }

}
